%GenD generates the structure of demand: D.

D.period=5; %Number of decision periods we wish to have
D.totaltime=c.Tsat; %Number of years over which we want to study the system
D.tstep=D.totaltime/D.period; %D.tstep is the time length of a period

D.initial=1e+005; %Initial demand (D0)
D.mu=0.05; %We assume there is no drift if mu=0; The drift rate is a percentage per year
%D.mu=(D.max/D.initial-1)/D.totaltime; %mu is the drift rate for demand.
                                      %We assume that without uncertainty, demand will increase from D0 to Dmax over the totaltime
D.sigma=0.4; %sigma is the volatility of our demand (0.02 means 2 percent per year)
D.up=exp(D.sigma*(D.tstep)^(1/2)); %If demand D goes up, after one period its value is D*u
D.down=1/D.up; %We should have u*d=1;
D.p=(exp(D.mu*D.tstep)-D.down)/(D.up- D.down); %Probability of going up
D.max=D.initial*(D.up)^(D.period); %Maximum demand that could be obtained
D.min=D.initial*(D.down)^(D.period); %Minimum demand that could be obtained
D.target=3e+006; %number of subscribers expected
D.capmin=1e+005; %Minimum capacity that our system should achieve
%NOTE: A binomial is feasible iff D.mu*(D.tstep)^(1/2)<=D.sigma. Otherwise, negative probabilities are obtained...