%Scenarios is useless and shouldn't be used. It is very slow compared to Binotree

% We want to create a matrix S with all the possible scenarios for demand [u,d,..,u,probability] and the associated probability.
% It is then translated into a demand matrix in which we see the evolution of D for each path

% 1/ Using the perms function, generate all the permutations of k u and D.periods-k d over a number of periods D.periods.
%   Those scenarios are collected in the matrix Sc.
%   Some of the rows of Sc are identical. We remove the unnecessary one using the sub-function eliminate.
%   The last column corresponds to the probability associated to the path
%   
function [S,demand,P]=scenarios(D);
u=D.up; d=D.down; n=D.period; S=[]; D0=D.initial;
p=D.p;
counter=0;
hfig=waitbar(0.01,'Please wait while the demand scenarios are generated','Position',[360 514 280 60]);
for i=0:n
    Xu=u*ones(1,i); Xd=d*ones(1,n-i);
    Xall=[Xu Xd];
    Sc=perms(Xall);
    Sc=eliminate(Sc);
    probability=(p^i)*(1-p)^(n-i); %probability associated with this type of paths
    [r,s]=size(Sc);
    prob=probability*ones(r,1);
    S=[S; [Sc prob]];
    counter=counter+1;
    waitbar(counter/n,hfig);
end

close (hfig)
% 2/ We create the vector demand that represents the evolution of demand through time
demand=[D0*S(:,1)];
for i=2:n
    demand=[demand S(:,i).*demand(:,i-1)];
end

%3/ We don't add any porbability vector of demand because the values in the matrix have very different orders of magnitude and we
%   we may end up with probabilities of zero everywhere.
%   We create a vector P that gathers in order the probabilitis (it is the last row of S)

P=S(:,n+1);
%Sub-function eliminate
%Given Sc, eliminate removes the rows that are repaeted.

function S=eliminate(Sc);
stop=0; k=1;%stop is a flag that tels us when to stop
while stop~=1
    [n,m]=size(Sc);
    a=Sc(k,:);
    if k==n
        stop=1;
    else
        for i=0:n-k-1
            if isequal(a,Sc(n-i,:))==1
                Sc(n-i,:)=[];
            else
            end
        end
        [n,m]=size(Sc);
        if k==n
        stop=1;
        else
            k=k+1;
        end
    end
end

S=Sc;