%NPV_distribution

%Given scenarios for the final costs (gathered in NPV) and their probabilities (in P)
%the function gives the final possible values for the costs (dNPV) and their probabilities (dP)

function [dNPV,dP]=NPV_ditribution(NPV,P)
%1/ First, we need to eliminate the identical values for cost in NPV
X=NPV;
stop=0; k=1;%stop is a flag that tels us when to stop
while stop~=1
    l=length(X);
    a=X(k);
    if k==l
        stop=1;
    else
        for i=0:l-k-1
            if a==X(l-i)
                X(l-i)=[];
            else
            end
        end
        l=length(X);
        if k==l;
        stop=1;
        else
            k=k+1;
        end
    end
end

%2/ We reorder the entries of X in increasing order
A=X;
X=[];
stop=0;
while stop~=1
    if length(A)==0;
        stop=1;
    else
        [c,i]=min(A);
        X=[X; c];
        A(i)=[];
    end
end

%3/ We create a vector dP with the probabilties of each final costs
l=length(X);
np=length(NPV);
dP=[];
for i=1:l
    totP=0;
    for k=1:np
        if NPV(k)==X(i)
            totP=totP+P(k);
        else
        end
    end
    dP=[dP; totP];
end

dNPV=X;
            
    