%We want to generate all the possible path existing from an architecture.

function S=fullpath(iref,x_all,Capm)

global Ta
%We generate the potential targets from architecture i
Tanc=ancestors(iref,x_all,Capm);
[h,t]=size(Tanc);
for i=0:t-1
    if Tanc(3,t-i)>Tanc(3,1)|Tanc(4,t-i)<Tanc(4,1) %We look at altitude and epsilon
        Tanc(:,t-i)=[];
    else
    end
end

Ta=Tanc; %it is the list  of our potential targets

X=[iref]; %We initialize X
flag=0; %Flag tells us when to stop the algorithm (flag=1)

while flag~=1;
    X;
    [n,p]=size(X);
    A=[];
    u=1; %u is a substitute for the flag
    for k=1:n
        if X(k,p)==0 %In this case, we are at the end of a path
            B=[X(k,:) 0];
        else
            B=nextarch(X(k,:));
            u=0; %u=0 because we have found a path that is not completed
        end
        A=[A; B];
    end
    
    if u==1 %In this case, the last X we have studied had a cloumn full of zero and we stop
        flag=1;
    else %We can go on and we update X
        X=A;
    end
end
S=X;
%subfunction

%nextarch
function X=nextarch(path)
global Ta
%We look for the last index of the path
l=length(path); iref=path(1,l);
Tar=Ta;
%We see what can be attained from iref
stop=0;
while stop~=1
    if Tar(2,1)~=iref
        Tar(:,1)=[];
    else
        stop=1;
    end
end

%We look at what should be a feasible target (compare altitude and epsilon)
[h,t]=size(Tar);
for i=0:t-1
    if Tar(3,t-i)>Tar(3,1)|Tar(4,t-i)<Tar(4,1) %We look at altitude and epsilon
        Tar(:,t-i)=[];
    else
    end
end

Tar(:,1)=[];%We get rid of the line containing iref

if Tar==[];
    X=[path 0];
else
    k=length(Tar(2,:));
    X=[[path 0]]; %We initialize with the path that doesn't move further
    for i=1:k
        X=[X; [path Tar(2,i)]];
    end
end
X;
