%Ranking

%Given an initial design vector Y, ranking finds all the architectures with same characteristics (except for altitude and epsilon) and
%rank them in increasing capacity giving altitudes and epsilon. All is gathered in the vector X in the following order:
% -Capacity (increasing with the columns)
% -i : rank of the architecture in x_all
% -altitude
% -epsilon

function X=ranking(x_all,Y,Capm)

%First, we find the set of indices for which the architectures have same constant characteristics and generate a vector Cap with those capacitites.
%We also create a first draft of X called D which is not ordered yet.
D=[]; Cap=[];
i=1;
while i<=length(x_all)
        if (x_all(i).Pt==Y.Pt)&(x_all(i).DA==Y.DA)&(x_all(i).Dfc==Y.Dfc)&(x_all(i).ISL==Y.ISL)&(x_all(i).Tsat==Y.Tsat)
        Cap=[Cap Capm(i)];
        D=[D [Capm(i); i; x_all(i).r; x_all(i).epsilon]];
        i=i+1;
    else
        i=i+1;
    end
end

%Then, we order those indices according to the associated Capacity and generate X.

X=[];
for k=1:15
    [C,I]=min(Cap); %C is the value of the minimum capacity and I its index in Cap  
    X=[X D(:,I)];
    Cap(:,I) = []; %We get rid of the I-th column of Cap
    D(:,I)=[]; %We get rid of the I-th column in D
    k=k+1;
end
X;