%For a given constellation, Tree gives all the possible constellations that could be built if epsilon is changed then r.
%First, the user has to define the starting point : the structure Y, [C r epsilon Pt DA Dfc ISL Tsat]
%To define Y (for instance): Y.C='polar'; Y.r=400; Y.epsilon=20; Y.Pt=200; Y.DA=1.5; Y.Dfc=40; Y.ISL=1; Y.Tsat=5;
%The program seeks the associated indice in x_all: iref. We have x_all(iref)=Y.
%The only difference with our previous code Tree is that Ctot is replaced by Capm as an input (new definition fo capacity)
function f=Tree(x_all,Y,Capm,LCC_unchanged)
LCC=LCC_unchanged/1000;
Ctot=Capm;
i=1;
while i<=length(x_all)
    if (x_all(i).r==Y.r)&(x_all(i).epsilon==Y.epsilon)&(x_all(i).Pt==Y.Pt)&(x_all(i).DA==Y.DA)&(x_all(i).Dfc==Y.Dfc)&(x_all(i).ISL==Y.ISL)&(x_all(i).Tsat==Y.Tsat)
        iref=i;
        break
    else
        i=i+1;
    end
end

%Changing only epsilon, we would like to see which constellations are possible.
%We create a matrix with all the indices of x_all for which we have the same constellation but only changed epsilon.
 
H=[];
i=1;
while i<=length(x_all)
        if (x_all(i).r==Y.r)&(x_all(i).Pt==Y.Pt)&(x_all(i).DA==Y.DA)&(x_all(i).Dfc==Y.Dfc)&(x_all(i).ISL==Y.ISL)&(x_all(i).Tsat==Y.Tsat)
        H=[H i];
        i=i+1;
    else
        i=i+1;
    end
end
H;


%First, we plot the entire constellations.
j1=1;
hold on;
while j1<=length(x_all)
    loglog(Ctot(j1)/1000,LCC(j1)/1000,'g+');
    j1=j1+1;
end

xlabel('Capacity [thousands of users]')
ylabel('System Lifecycle Cost [B$]')
title(['Trade Space'])


loglog(Ctot(iref)/1000, LCC(iref)/1000,'b+');

%Then, for each possible case, we draw a branch and the leaves.
n=length(H);
i=1;
while i<=n
loglog(Ctot(H(i))/1000, LCC(H(i))/1000,'r+');
line([Ctot(iref)/1000 Ctot(H(i))/1000],[LCC(iref)/1000 LCC(H(i))/1000]);
radius(x_all,H(i),Ctot,LCC);
i=i+1;
end

%Sub-function
function f=radius(x_all,K,Ctot,LCC)
i=1;
Y=x_all(K);
while i<=length(x_all)
    if (x_all(i).r==Y.r)&(x_all(i).epsilon==Y.epsilon)&(x_all(i).Pt==Y.Pt)&(x_all(i).DA==Y.DA)&(x_all(i).Dfc==Y.Dfc)&(x_all(i).ISL==Y.ISL)&(x_all(i).Tsat==Y.Tsat)
        iref=i;
        break
    else
        i=i+1;
    end
end

%Changing only the radius, we would like to see which constellations are possible.
%We create a matrix with all the indices of x_all for which we have the same constellation but only changed the radius.
 
H=[];
i=1;
while i<=length(x_all)
        if (x_all(i).r~=Y.r)&(x_all(i).epsilon==Y.epsilon)&(x_all(i).Pt==Y.Pt)&(x_all(i).DA==Y.DA)&(x_all(i).Dfc==Y.Dfc)&(x_all(i).ISL==Y.ISL)&(x_all(i).Tsat==Y.Tsat)
        H=[H i];
        i=i+1;
    else
        i=i+1;
    end
end
H;

hold on;

%Then, for each possible case, we draw a branch.
n=length(H);
i=1;
while i<=n
loglog(Ctot(H(i))/1000, LCC(H(i))/1000,'ro');
line([Ctot(iref)/1000 Ctot(H(i))/1000],[LCC(iref)/1000 LCC(H(i))/1000]);
i=i+1;
end
