function h=plotfullpath(i,x_all,Capm,LCC_unchanged)
iref=i;
X=fullpath(i,x_all,Capm); %We generate the matrix of feasible paths for i
[nx,mx]=size(X);
LCC=LCC_unchanged/1000;
hold on;

loglog(Capm/1000,LCC/1000,'g+'); %We plot the Trade Space

for j=1:nx
    A=X(j,:);
    stop=0;
%We get rid of the potential zeros in A
    while stop~=1
        ma=length(A);
        if A(ma)==0
            A(ma)=[];
        else
            stop=1;
        end
    end
    
    path=A;
    n=length(path);
    if n==1
    plot(Capm(path)/1000,LCC(path)/1000,'ro');
    else
    for i=2:n
        line([Capm(path(i-1))/1000 Capm(path(i))/1000],[LCC(path(i-1))/1000 LCC(path(i))/1000],'Color','b');
    end
    end
end

%finally, we circle al the architectures that can be reached by the architecture i.
Tanc=ancestors(iref,x_all,Capm);
[h,t]=size(Tanc);
for i=0:t-1
    if Tanc(3,t-i)>Tanc(3,1)|Tanc(4,t-i)<Tanc(4,1) %We look at altitude and epsilon
        Tanc(:,t-i)=[];
    else
    end
end

Ta=Tanc; %it is the list  of our potential targets
l=length(Ta);
Ta
for k=1:l
    plot(Capm(Ta(2,k))/1000, LCC(Ta(2,k))/1000,'ro');
end

xlabel('Capacity [thousands of users]')
ylabel('System Lifecycle Cost [B$]')
title(['Feasible paths with architecture #',num2str(iref),''])