% supfamily
% Given an architecture Y, supfamily will give all of the architectures of the same family with higher capacities and rank them.
% All is gathered in the vector X in the following order:
% -Capacity (increasing with the columns)
% -i: rank of the architecture in x_all
% -altitude
% -epsilon

function X=supfamily(x_all,Y,Capm)

%1/ We find the set of indices for which the architectures have same constant characteristics and generate a vector Cap with those capacitites.
%We also create a first draft of X called D which is not ordered yet.
%Capacity is devided by 10^6 in D for clarity in the results
D=[]; Cap=[];
i=1; nx=length(x_all);
while i<=nx
        if (x_all(i).Pt==Y.Pt)&(x_all(i).DA==Y.DA)&(x_all(i).Dfc==Y.Dfc)&(x_all(i).ISL==Y.ISL)&(x_all(i).Tsat==Y.Tsat)
            Cap=[Cap Capm(i)];
            D=[D [Capm(i); i; x_all(i).r; x_all(i).epsilon]];
            i=i+1;
        else
            i=i+1;
    end
end

%2/ We try to find which capacity correspond to Y using the subfunction finder
iref=finder(x_all,Y);

%3/ Then, we order the indices according to the associated Capacity and generate X.
X=[];
for k=1:15
    [C,I]=min(Cap); %C is the value of the minimum capacity and I its index in Cap  
    X=[X D(:,I)];
    Cap(:,I) = []; %We get rid of the I-th column of Cap
    D(:,I)=[]; %We get rid of the I-th column in D
    k=k+1;
end

%4/ We remove all of the architectures that have a lower capacity than Y in X
stop=0;
while stop~=1
    if X(2,1)~=iref
        X(:,1)=[];
    else
        stop=1;
    end
end
X;

        

