% function linkDesign
% Module that computes Bit Error Rate (BER)
% based on link budget of a route

% Darren Zhang (darrenz@mit.edu)
% Last modified by 1/26/01

% problems yet to be solved
% 1. find the right range b/w the satellite - satellite link.  It's not slantRange.
% 2. estimate the max. antenna pointing offset angle of transmitter.
% 3. estimate atmospheric loss using ITU-R P676-4
% 4. find out how to calculate beamwidth for PHASED-ARRAY ANTENNA

function BERTotal = linkDesign(route,freqUS,freqSU,freqGS,freqSG,freqSS,powerUser,powerGS,powerSat,DUser,DSatR,DSatT,DGSR,DGST,EffT,EffR,slantRange,dataRate);

BERTotal = 0;

for i = 1:(length(route) - 1)
   if route(i) == 1 & route(i+1) == 3		% user to sat. link
      BER(i) = getBER(freqUS,powerUser,DUser,DSatR,EffT,EffR,slantRange,1,dataRate);
   elseif route(i) == 3 & route(i+1) == 1		% sat. to user link
      BER(i) = getBER(freqSU,powerSat,DSatT,DUser,EffT,EffR,slantRange,2,dataRate);
   elseif route(i) == 2 & route(i+1) == 3		% ground station to sat. link
      BER(i) = getBER(freqGS,powerGS,DGST,DSatR,EffT,EffR,slantRange,1,dataRate);
   elseif route(i) == 3 & route(i+1) == 2		% sat. to ground station link
      BER(i) = getBER(freqSG,powerSat,DSatT,DGSR,EffT,EffR,slantRange,2,dataRate);
   elseif route(i) == 3 & route(i+1) == 3		% ground station to sat. link
      BER(i) = getBER(freqSS,powerSat,DSatT,DSatR,EffT,EffR,slantRange,3,dataRate);
   end;
   % assume regenerative satellites
   % total BER = sum(BER_i)
   BERTotal = BERTotal + BER(i);	
end;



   
         
      

      
