% root1DataInput.m
% This is part 1 of the root module of the simulator
% LEOSatComm.
% It asks for inputs to the constant variables and
% design variables.

% last modified on 3/17/02
% by Darren Chang (darrenz@mit.edu)

% constant input section
fprintf('Input the following constants (They will stay constant throughout the program):\n\n');
EffT = input('\nefficiency of all transmitters in percentage = ');	% percentage
EffR = input('\nefficiency of all receivers in percentage = ');		% percentage
BERTotal = input('\ntotal bit error rate along the link = ');		% bit/bit
DR = input('\ndiscount rate in percentage = ');								% percentage
powerUser = input('\nuser termianl power (W) = ');							% Watt
DUser = input('\nuser termianl diameter (m) = ');							% meter
userBW = input('\nuser bandwidth (kbps) = ');                           % kbps
freqUS = input('\nuser to satellite frequency (GHz) = ');				% GHz
freqSU = input('\nsatellite to user frequency (GHz) = ');				% GHz
freqGS = input('\nground station to satellite frequency (GHz) = ');	% GHz
freqSG = input('\nsatellite to ground station frequency (GHz) = ');	% GHz
freqSS = input('\nsatellite to satellite crosslink frequency (GHz) = '); % GHz
IDTime = input('\ninitial deployment time (years) = ');					% year
spaceLife = input('\nspace life of the system (years) = ');				% year
marketSize = input('\nmarket demand (number of people) = ');            % number of people
select = input('\nPlease enter 1 or 2 for what you want to do:\n1.Full iteration of the design vectors for optimization\n2.1 dimensional sensitivity analysis of a design parameter\n');

if select == 1
   % design variable section
	fprintf('\nInput the upper and lower limits of the design variables,\n');
	fprintf('and number of data points between the limits.\n\n');

	constel   = 1;	% when the Walker part is done, constel = [1,2]
	constel_n = 1;

	alti_l   = input('Enter lower orbit altitude of the satellite in kilometer: ');		% km
	alti_u   = input('Enter upper orbit altitude of the satellite in kilometer: ');		% km
	alti_n	= input('Enter number of data points between the lower and upper altitudes: ');
	alti		= linspace(alti_l,alti_u,alti_n);

	elev_l	= pi/180*input('\nEnter lower minimum elevation angle in degrees: ');			% radian
	elev_u	= pi/180*input('Enter upper minimum elevation angle in degrees: ');			% radian
	elev_n	= input('Enter number of data points between the lower and upper elevation angles: ');
	elev		= linspace(elev_l,elev_u,elev_n);

	powerSat_l	= input('\nEnter lower satellite transmitter power in Watts: ');			% Watts
	powerSat_u	= input('Enter upper satellite transmitter power in Watts: ');			% Watts
	powerSat_n	= input('Enter number of data points between the lower and upper powers: ');
	powerSat		= linspace(powerSat_l,powerSat_u,powerSat_n);

	DSatR_l	= input('\nEnter lower satellite receiver antenna diameter in meters: ');			% meters
	DSatR_u	= input('Enter upper satellite receiver antenna diameter in meters: ');			% meters
	DSatR_n	= input('Enter number of data points between the lower and upper diameters: ');
	DSatR		= linspace(DSatR_l,DSatR_u,DSatR_n);

	DSatT_l	= input('\nEnter lower satellite transmitter antenna diameter in meters: ');			% meters
	DSatT_u	= input('Enter upper satellite transmitter antenna diameter in meters: ');			% meters
	DSatT_n	= input('Enter number of data points between the lower and upper diameters: ');
	DSatT		= linspace(DSatT_l,DSatT_u,DSatT_n);
    
    %xlink = input('\nEnter 1 if satellites have crosslinks and 0 for NO crosslinks: ');

	powerGS_l	= input('\nEnter lower ground station transmitter power in Watts: ');			% Watts
	powerGS_u	= input('Enter upper ground station transmitter power in Watts: ');			% Watts
	powerGS_n	= input('Enter number of data points between the lower and upper powers: ');
	powerGS		= linspace(powerGS_l,powerGS_u,powerGS_n);

	DGSR_l	= input('\nEnter lower ground station receiver antenna diameter in meters: ');			% meters
	DGSR_u	= input('Enter upper ground station receiver antenna diameter in meters: ');			% meters
	DGSR_n	= input('Enter number of data points between the lower and upper diameters: ');
	DGSR		= linspace(DGSR_l,DGSR_u,DGSR_n);

	DGST_l	= input('\nEnter lower ground station transmitter antenna diameter in meters: ');		% meters
	DGST_u	= input('Enter upper ground station transmitter antenna diameter in meters: ');		% meters
	DGST_n	= input('Enter number of data points between the lower and upper diameters: ');
    DGST		= linspace(DGST_l,DGST_u,DGST_n);
elseif select == 2
   fprintf('\nEnter index number of the design variable whose sensitivity you want to find out:\n')
   fprintf('1.constellation type\n2.altitude\n3.minimum elevation\n4.satellite power\n5.satellite transmitter diameter\n');
   fprintf('6.satellite receiver diameter\n7.ground station power\n8.ground station receiver diameter\n');
   index = input('9.ground station transmitter diameter');
   
   if index == 1
      constel 	 = [1,2];
      constel_n = 2;
   else
      constel   = input('Enter index number of the type of constellation:\n1.polar\n2.Walker\n');
      constel_n = 1;
   end;
   
   if index == 2
      alti_m	= input('Enter midpoint of orbit altitude of the satellite in kilometer: \n');
      alti_l   = input('Enter lower orbit altitude of the satellite in kilometer: \n');		% km
      alti_u   = input('Enter upper orbit altitude of the satellite in kilometer: \n');		% km
      alti_n	= 3;
      alti		= [alti_l,alti_m,alti_u];
   else
      alti		= input('Enter a constant value for orbit altitude of the satellite in kilometer: \n');
		alti_n	= 1;
   end;
   
   if index == 3
      elev_m	= pi/180*input('Enter midpoint of elevation angle in degrees: ');
      elev_l	= pi/180*input('Enter lower minimum elevation angle in degrees: ');			% radian
      elev_u	= pi/180*input('Enter upper minimum elevation angle in degrees: ');			% radian
      elev_n	= 3;
      elev		= [elev_l,elev_m,elev_u];
   else
      elev		= input('Enter a constant value for minimum elevation angle in degrees: \n');
      elev_n	= 1;
   end;
   
   if index == 4
		powerSat_m	= input('Enter midpoint of satellite transmitter power in Watts: ');
      powerSat_l	= input('Enter lower satellite transmitter power in Watts: ');			% Watts
      powerSat_u	= input('Enter upper satellite transmitter power in Watts: ');			% Watts
      powerSat_n	= 3;
      powerSat		= [powerSat_l,powerSat_m,powerSat_u];
   else
      powerSat		= input('Enter a constant value for satellite transmitter power in Watts: \n');
      powerSat_n	= 1;
   end;
   
   if index == 5
		DSatR_m	= input('Enter midpoint of satellite receiver antenna diamter in meters: ');
   	DSatR_l	= input('Enter lower satellite receiver antenna diameter in meters: ');			% meters
      DSatR_u	= input('Enter upper satellite receiver antenna diameter in meters: ');			% meters
      DSatR_n	= 3;
      DSatR		= [DSatR_l,DSatR_m,DSatR_u];
   else
      DSatR		= input('Enter a constant value for satellite receiver antenna diameter in meters: \n');
      DSatR_n	= 1;
   end;
   
   if index == 6
      DSatT_m	= input('Enter midpint of satellite transmitter antenna diameter in meters: ');	
   	DSatT_l	= input('Enter lower satellite transmitter antenna diameter in meters: ');			% meters
      DSatT_u	= input('Enter upper satellite transmitter antenna diameter in meters: ');			% meters
      DSatT_n  = 3;
      DSatT		= [DsatT_l,DsatT_m,DsatT_u];
   else
      DSatT		= input('Enter a constant value for satellite transmitter antenna diameter in meters: \n');
      DSatT_n  = 1;
   end;
   
   if index == 7
	  powerGS_m	= input('Enter midpoint of ground station transmitter power in Watts: ');
      powerGS_l	= input('Enter lower ground station transmitter power in Watts: ');			% Watts
      powerGS_u	= input('Enter upper ground station transmitter power in Watts: ');			% Watts
      powerGS_n	= 3;
      powerGS		= [powerGS_l,powerGS_m,powerGS_u];
   else
      powerGS		= input('Enter a constant value for ground station transmitter power in Watts: \n');
      powerGS_n	= 1;
   end;

   if index == 8
		DGSR_m	= input('Enter midpoint of ground station receiver antenna diamter in meters: ');
   	DGSR_l	= input('Enter lower ground station receiver antenna diameter in meters: ');			% meters
      DGSR_u	= input('Enter upper ground station receiver antenna diameter in meters: ');			% meters
      DGSR_n	= 3;
      DGSR		= [DGSR_l,DGSR_m,DGSR_u];
   else
      DGSR		= input('Enter a constant value for ground station receiver antenna diameter in meters: \n');
      DGSR_n	= 1;
   end;
   
   if index == 9
      DGST_m	= input('Enter midpint of ground station transmitter antenna diameter in meters: ');	
   	DGST_l	= input('Enter lower ground station transmitter antenna diameter in meters: ');			% meters
      DGST_u	= input('Enter upper ground station transmitter antenna diameter in meters: ');			% meters
      DGST_n  = 3;
      DGST		= [DGST_l,DGST_m,DGST_u];
   else
      DGST		= input('Enter a constant value for ground station transmitter antenna diameter in meters: \n');
      DGST_n  = 1;
   end;
end;
   
%root2Iteration;











