% root2Iteration.m
% This is part 2 of the root module of the simulator
% LEOSatComm.
% It iterates the entire design variable space for either optimization
% or sensitivity analysis.

% last modified on 3/27/02
% by Darren Zhang (darrenz@mit.edu)

% problems yet to be solved:
% 1. optimization methods

objectiveFunc_last = 0;
for constel_i = 1:constel_n
   for alti_i = 1:alti_n
   	for elev_i = 1:elev_n
      	for powerSat_i = 1:powerSat_n
         	for DSatR_i = 1:DSatR_n
               for DSatT_i = 1:DSatT_n
                   for xlink = 0:1
                   result_count = (constel_i-1)*alti_n*elev_n*powerSat_n*DSatR_n*DSatT_n*2 + (alti_i-1)*elev_n*powerSat_n*DSatR_n*DSatT_n*2 + (elev_i-1)*powerSat_n*DSatR_n*DSatT_n*2 + (powerSat_i-1)*DSatR_n*DSatT_n*2 + (DSatR_i-1)*DSatT_n*2 + (DSatT_i-1)*2 + (xlink+1);
                  % coverage module
                  [slantRange,dist,incli,Nmin,NSmin,NPmin,orbitR,delta,central] = coverage(constel(constel_i),alti(alti_i),elev(elev_i));
                  % network module
                  [GSKLOC,NGS,personnel] = satNetwork(constel(constel_i),xlink,Nmin,NPmin);
                  % spacecraft module
                  [Msat,Vsat,AntW,CEW,SCBDW,BLP,AKM,AKMDW,FSKLOC,totImpulse] = spacecraft(powerSat(powerSat_i),DSatT(DSatT_i),DSatR(DSatR_i),xlink,GSKLOC);
                  % launch vehicle (LV) module
				  [launchVehicle,LVModelFileName,satPerVehicle,numberOfLaunch,launchSite,LPModelFileName,LSla,LSlo,LSR,minLaunchCost,LScounter,costPerLaunchl,costPerLaunchh,burnoutVelocity] = LV(Msat,Vsat,incli,Nmin,alti(alti_i));
                  % link design module
                  route = [3,1];	% a route that goes sat->user
                  if LScounter == 0 % no LV is capable of the launch
                      userPerSat = 0;
                  else
                      userPerSat = linkDesign(freqSU,powerSat(powerSat_i),DSatT(DSatT_i),DUser,EffT,EffR,slantRange,2,BERTotal,userBW);
                  end;
                  % cost module
                  [totalPresentCost(result_count),costSDAvg] = cost(Nmin,NPmin,alti(alti_i),AntW,CEW,SCBDW,Msat,BLP,FSKLOC,GSKLOC,spaceLife,IDTime,NGS,personnel,AKM,AKMDW,totImpulse,DR,minLaunchCost);
                  % customer module
                  customerNumber(result_count) = customer(NPmin,NSmin,incli,alti(alti_i),userPerSat,marketSize,elev(elev_i));
                  constel_(result_count) = constel(constel_i);
                  alti_(result_count) = alti(alti_i);
                  elev_(result_count) = elev(elev_i);
                  powerSat_(result_count) = powerSat(powerSat_i);
                  DSatT_(result_count) = DSatT(DSatT_i);
                  DSatR_(result_count) = DSatR(DSatR_i);
                  xlink_(result_count) = xlink;
                  Nmin_(result_count) = Nmin;
                  NPmin_(result_count) = NPmin;
                  NSmin_(result_count) = NSmin;
                  orbitR_(result_count) = orbitR;
                  Msat_(result_count) = Msat;
                  launchVehicle_(result_count) = launchVehicle;
                  numberOfLaunch_(result_count) = numberOfLaunch;
                  userPerSat_(result_count) = userPerSat;
                  NGS_(result_count) = NGS;
                  ISL_(result_count) = xlink;
                  % objective function
                     objectiveFunc = customerNumber*10000*spaceLife/1000 - totalPresentCost;	% in FY2002$K
                     if objectiveFunc > objectiveFunc_last
                        objectiveFunc_last	= objectiveFunc;
                        finalDSatT_i 			= DSatT_i;
                        finalDSatR_i 			= DSatR_i;
                        finalpowerSat_i		= powerSat_i;
                        finalelev_i				= elev_i;
                        finalalti_i				= alti_i;
                        finalconstel_i			= constel_i;
                        finaldelta				= delta;
                        finalcentral			= central;
                        finalincli				= incli;
                        finallaunchVehicle	= launchVehicle;
                        finalLVModelFileName	= LVModelFileName;
                        finalsatPerVehicle	= satPerVehicle;
                        finalnumberOfLaunch	= numberOfLaunch;
                        finallaunchSite		= launchSite;
                        finalLPModelFileName	= LPModelFileName;
                        finalLSla				= LSla;
                        finalLSlo				= LSlo;
                        finalLSR				= LSR;
                        finalminLaunchCost	= minLaunchCost;
                        finalNPmin				= NPmin;
                        finalNSmin				= NSmin;
                        finalorbitR				= orbitR;
                        finalLScounter			= LScounter;
                        finalcostPerLaunchl	= costPerLaunchl;
                        finalcostPerLaunchh	= costPerLaunchh;
                        finalburnoutVelocity	= burnoutVelocity;
                     else
                        ;
                     end;
                 end;   
               end;
            end;
         end;
      end;
   end;
end;
systemCapacity = userPerSat_.*Nmin_;

%stk(finaldelta,finalcentral,finalorbitR,finalincli,alti(finalalti_i),finalNPmin,finalNSmin,finalLScounter,finallaunchSite,finallaunchVehicle,finalLVModelFileName,finalsatPerVehicle,finalnumberOfLaunch,finalLPModelFileName,finalLSla,finalLSlo,finalburnoutVelocity);

%displayResult
             
save LEOcomm_DB
