% x Odyssey design vector
% Design Vector (single architecture evaluation)
C='polar';      % constellation type [options: 'polar','walker']
r=10354;        % orbital altitude [km]
epsilon=20.0;   % minimum elevation angle [deg]
Pt=6177;        % satellite transmitter power [W]
DA=1.6;         % satellite antenna diameter [D] - assume parabolic not phased array
Dfc=5500;       % individual channel bandwidth [kHz]
ISL=0;          % intersatellite links (1=yes, 0=no)
Tsat=15;        % satellite lifetime [years]

x.C=C;
x.r=r;
x.epsilon=epsilon;
x.Pt=Pt;
x.DA=DA;
x.Dfc=Dfc;
x.ISL=ISL;
x.Tsat=Tsat;

xunits.C='[constellation type]';
xunits.r='[km]';
xunits.epsilon='[deg]';
xunits.Pt='[W]';
xunits.DA='[m]';
xunits.Dfc='[kHz]';
xunits.ISL='[1=yes,0=no]';
xunits.Tsat='[years]';
