% run_all

clear all
close all

% Requirements Vector
BER=1e-3;    % bit-error-rate
R=4.8;       % data rate per channel here 4.8 kbps  (4.8 kbps for voice, 2.4 kbps data internet dialup)
margin=16;   % link (fading) margin [dB]

r.BER=BER;
r.R=R;
r.margin=margin;

runits.BER='[-]';
runits.R='[kbps]';
runits.margin='[dB]';

% Constants Vector (fixed parameters) 

MS='QPSK';            %  Modulation scheme
Pe=0.5  ;             %  [W] satellite telephone power
MAM='CDMA';           %  Multiple Access Method
Ge=1;                 %  Gain of satellite phone - NOT in dB
incli=90;             %  (max) inclination (latitude)
eta_t=55;             %  satellite transmitter efficiency in percent
DR=0;                 %  discount rate in percent
GB=2.08;              %  width of a typical guardband

c.MS=MS;
c.Pe=Pe; 
c.MAM=MAM;
c.Ge=Ge;
c.incli=incli;
c.eta_t=eta_t;
c.DR=DR;
c.GB=GB;

cunits.MS='[modulation]';
cunits.Pe='[W]';
cunits.MAM='[muliple access method]';
cunits.Ge='[-]';
cunits.incli='[radians]';
cunits.eta_t='[%]';
cunits.DR='[%]';
cunits.GB='[kHz]';

Fms_uplink_lb=1.61600;  % mobile/satellite uplink frequency lower bound [GHz]
Fms_uplink_ub=1.62650;  % mobile/satellite uplink frequency upper bound [GHz]
Fms_downlink_lb=1.61600;
Fms_downlink_ub=1.62650;

p.Fms_uplink_lb=Fms_uplink_lb;
p.Fms_uplink_ub=Fms_uplink_ub;
p.Fms_downlink_lb=Fms_downlink_lb;
p.Fms_downlink_ub=Fms_downlink_ub;

punits.Fms_uplink_lb='[GHz]';
punits.Fms_uplink_ub='[GHz]';
punits.Fms_downlink_lb='[GHz]';
punits.Fms_downlink_ub='[GHz]';


% no launch vehicle restrictions

% no gateway placement/licensing restrictions


% run tradespace analysis

xv.C='polar';    % constellation type [options: 'polar','walker']
xv.r=800;        % orbital altitude [km]
xv.epsilon=15;  % minimum elevation angle [deg]
xv.Pt=200;      % satellite transmitter power [W]
xv.DA=3.5;       % ??? satellite antenna diameter [D] - assume parabolic not phased array
xv.Dfc=40;    % individual channel bandwidth [kHz]
xv.ISL=1;        % intersatellite links (1=yes, 0=no)
xv.Tsat=10;       % satellite lifetime [years]

xunits.C='[constellation type]';
xunits.r='[km]';
xunits.epsilon='[deg]';
xunits.Pt='[W]';
xunits.DA='[m]';
xunits.Dfc='[kHz]';
xunits.ISL='[1=yes,0=no]';
xunits.Tsat='[years]';

[x,xunits,J,Junits,B,Bunits]=run_leo(xv,c,r,p,xunits,cunits,runits,punits)