% demand Monte Carlo simulation
S=50000; % initial demand
T=[1:1:15*12]; % monthly time intervals
dt=1;
mu=0.08/12; % expect 10% increase per year
sigma=0.4/12; % 30% volatility p.a.
for ind=1:length(T)
    dS=(mu*dt+sigma*randn(1)*sqrt(dt))*S(ind);
    S(ind+1)=S(ind)+dS;
end
plot([0 T/12], S,'k-')
xlabel('Time [years]')
ylabel('Demand [N_u_s_e_r]')
title('Demand Brownian Motion Model: MonteCarlo Simulation')

    