FID_Output = fopen('cost_vs_customer.doc', 'w');

if FID_Output == -1
    % Error if FID is -1.
    disp( 'Error reading the file cost_vs_customer.doc' )
else
    % Write the header
    fprintf(FID_Output, 'Write the result of the simulator:\n');
    fprintf(FID_Output, 'Count          Number_of_Customers       Total_Present_Cost    Costellation_Type   Altitude    Elevation_Angle     Sat._Power  Sat._Transmitter_Dia\n');
    % Write the values of results
    for i = 1:result_count
        fprintf(FID_Output,'%6.0f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f\n',i,customerNumber(i),totalPresentCost(i),constel_(i),alti_(i),elev_(i),powerSat_(i),DSatT_(i));
    end;
    
    [TPC_pareto,capacity_pareto,index_pareto] = ParetoFront(totalPresentCost,systemCapacity);
    
    fprintf(FID_Output, 'On the Pareto front of Total Present Cost vs. Capcity plot\n');
    fprintf(FID_Output, 'Count          Number_of_Customers       Total_Present_Cost    Costellation_Type   Altitude    Elevation_Angle     Sat._Power  Sat._Transmitter_Dia\n');
    for i = 1:size(TPC_pareto,1)
        fprintf(FID_Output, '%6.0f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f\n', i,customerNumber(index_pareto(i)),TPC_pareto(i),constel_(index_pareto(i)),alti_(index_pareto(i)),elev_(index_pareto(i)),powerSat_(index_pareto(i)),DSatT_(index_pareto(i)));
    end;
    
    % Close the output file
    fclose(FID_Output);
end;